"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateDeletePeerconnectionsByPeerconnectionIdOutput = exports.validateDeletePeerconnectionsByPeerconnectionIdInput = exports.validateGetPeerconnectionsByPeerconnectionIdOutput = exports.validateGetPeerconnectionsByPeerconnectionIdInput = exports.validatePostPeerconnectionsOutput = exports.validatePostPeerconnectionsInput = exports.validateGetPeerconnectionsOutput = exports.validateGetPeerconnectionsInput = exports.validatePostDevicesByDeviceIdSignalingOutput = exports.validatePostDevicesByDeviceIdSignalingInput = exports.validatePostDevicesByDeviceIdWebsocketOutput = exports.validatePostDevicesByDeviceIdWebsocketInput = exports.validatePostDevicesByDeviceIdAvailabilityOutput = exports.validatePostDevicesByDeviceIdAvailabilityInput = exports.validatePostDevicesByDeviceIdOutput = exports.validatePostDevicesByDeviceIdInput = exports.validateDeleteDevicesByDeviceIdOutput = exports.validateDeleteDevicesByDeviceIdInput = exports.validatePatchDevicesByDeviceIdOutput = exports.validatePatchDevicesByDeviceIdInput = exports.validateGetDevicesByDeviceIdOutput = exports.validateGetDevicesByDeviceIdInput = exports.validatePostDevicesOutput = exports.validatePostDevicesInput = exports.validateGetDevicesOutput = exports.validateGetDevicesInput = void 0;
const basicValidation_1 = require("./basicValidation");
/**
 * This function validates the inputs of a GET request on /devices
 */
function validateGetDevicesInput() {
    return true;
}
exports.validateGetDevicesInput = validateGetDevicesInput;
/**
 * This function validates the outputs to a GET request on /devices
 */
function validateGetDevicesOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validateGetDevicesResponse200)(response.body)) {
            validateGetDevicesOutput.errors = basicValidation_1.validateGetDevicesResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetDevicesOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetDevicesOutput = validateGetDevicesOutput;
/**
 * This function validates the inputs of a POST request on /devices
 */
function validatePostDevicesInput(parameters, body) {
    if (parameters) {
        if (parameters["changedUrl"] &&
            !(0, basicValidation_1.validateChangedUrl)(parameters["changedUrl"])) {
            validatePostDevicesInput.errors = basicValidation_1.validateChangedUrl.errors;
            return false;
        }
    }
    if (!(0, basicValidation_1.validatePostDevicesRequestBody)(body)) {
        validatePostDevicesInput.errors = basicValidation_1.validatePostDevicesRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePostDevicesInput = validatePostDevicesInput;
/**
 * This function validates the outputs to a POST request on /devices
 */
function validatePostDevicesOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 201) {
        if (!(0, basicValidation_1.validatePostDevicesResponse201)(response.body)) {
            validatePostDevicesOutput.errors = basicValidation_1.validatePostDevicesResponse201.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostDevicesOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostDevicesOutput = validatePostDevicesOutput;
/**
 * This function validates the inputs of a GET request on /devices/{device_id}
 */
function validateGetDevicesByDeviceIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validateGetDevicesByDeviceIdInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
        if (parameters["flat_group"] &&
            !(0, basicValidation_1.validateFlatGroup)(parameters["flat_group"])) {
            validateGetDevicesByDeviceIdInput.errors = basicValidation_1.validateFlatGroup.errors;
            return false;
        }
    }
    return true;
}
exports.validateGetDevicesByDeviceIdInput = validateGetDevicesByDeviceIdInput;
/**
 * This function validates the outputs to a GET request on /devices/{device_id}
 */
function validateGetDevicesByDeviceIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validateGetDevicesByDeviceIdResponse200)(response.body)) {
            validateGetDevicesByDeviceIdOutput.errors = basicValidation_1.validateGetDevicesByDeviceIdResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetDevicesByDeviceIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetDevicesByDeviceIdOutput = validateGetDevicesByDeviceIdOutput;
/**
 * This function validates the inputs of a PATCH request on /devices/{device_id}
 */
function validatePatchDevicesByDeviceIdInput(parameters, body) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validatePatchDevicesByDeviceIdInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
        if (parameters["changedUrl"] &&
            !(0, basicValidation_1.validateChangedUrl)(parameters["changedUrl"])) {
            validatePatchDevicesByDeviceIdInput.errors = basicValidation_1.validateChangedUrl.errors;
            return false;
        }
    }
    if (body && !(0, basicValidation_1.validatePatchDevicesByDeviceIdRequestBody)(body)) {
        validatePatchDevicesByDeviceIdInput.errors = basicValidation_1.validatePatchDevicesByDeviceIdRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePatchDevicesByDeviceIdInput = validatePatchDevicesByDeviceIdInput;
/**
 * This function validates the outputs to a PATCH request on /devices/{device_id}
 */
function validatePatchDevicesByDeviceIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validatePatchDevicesByDeviceIdResponse200)(response.body)) {
            validatePatchDevicesByDeviceIdOutput.errors = basicValidation_1.validatePatchDevicesByDeviceIdResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePatchDevicesByDeviceIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePatchDevicesByDeviceIdOutput = validatePatchDevicesByDeviceIdOutput;
/**
 * This function validates the inputs of a DELETE request on /devices/{device_id}
 */
function validateDeleteDevicesByDeviceIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validateDeleteDevicesByDeviceIdInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
    }
    return true;
}
exports.validateDeleteDevicesByDeviceIdInput = validateDeleteDevicesByDeviceIdInput;
/**
 * This function validates the outputs to a DELETE request on /devices/{device_id}
 */
function validateDeleteDevicesByDeviceIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 204) {
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateDeleteDevicesByDeviceIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateDeleteDevicesByDeviceIdOutput = validateDeleteDevicesByDeviceIdOutput;
/**
 * This function validates the inputs of a POST request on /devices/{device_id}
 */
function validatePostDevicesByDeviceIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validatePostDevicesByDeviceIdInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
        if (parameters["changedUrl"] &&
            !(0, basicValidation_1.validateChangedUrl)(parameters["changedUrl"])) {
            validatePostDevicesByDeviceIdInput.errors = basicValidation_1.validateChangedUrl.errors;
            return false;
        }
    }
    return true;
}
exports.validatePostDevicesByDeviceIdInput = validatePostDevicesByDeviceIdInput;
/**
 * This function validates the outputs to a POST request on /devices/{device_id}
 */
function validatePostDevicesByDeviceIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 201) {
        if (!(0, basicValidation_1.validatePostDevicesByDeviceIdResponse201)(response.body)) {
            validatePostDevicesByDeviceIdOutput.errors = basicValidation_1.validatePostDevicesByDeviceIdResponse201.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostDevicesByDeviceIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostDevicesByDeviceIdOutput = validatePostDevicesByDeviceIdOutput;
/**
 * This function validates the inputs of a POST request on /devices/{device_id}/availability
 */
function validatePostDevicesByDeviceIdAvailabilityInput(parameters, body) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validatePostDevicesByDeviceIdAvailabilityInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
    }
    if (body && !(0, basicValidation_1.validatePostDevicesByDeviceIdAvailabilityRequestBody)(body)) {
        validatePostDevicesByDeviceIdAvailabilityInput.errors = basicValidation_1.validatePostDevicesByDeviceIdAvailabilityRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePostDevicesByDeviceIdAvailabilityInput = validatePostDevicesByDeviceIdAvailabilityInput;
/**
 * This function validates the outputs to a POST request on /devices/{device_id}/availability
 */
function validatePostDevicesByDeviceIdAvailabilityOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validatePostDevicesByDeviceIdAvailabilityResponse200)(response.body)) {
            validatePostDevicesByDeviceIdAvailabilityOutput.errors = basicValidation_1.validatePostDevicesByDeviceIdAvailabilityResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostDevicesByDeviceIdAvailabilityOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostDevicesByDeviceIdAvailabilityOutput = validatePostDevicesByDeviceIdAvailabilityOutput;
/**
 * This function validates the inputs of a POST request on /devices/{device_id}/websocket
 */
function validatePostDevicesByDeviceIdWebsocketInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validatePostDevicesByDeviceIdWebsocketInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
    }
    return true;
}
exports.validatePostDevicesByDeviceIdWebsocketInput = validatePostDevicesByDeviceIdWebsocketInput;
/**
 * This function validates the outputs to a POST request on /devices/{device_id}/websocket
 */
function validatePostDevicesByDeviceIdWebsocketOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validatePostDevicesByDeviceIdWebsocketResponse200)(response.body)) {
            validatePostDevicesByDeviceIdWebsocketOutput.errors = basicValidation_1.validatePostDevicesByDeviceIdWebsocketResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostDevicesByDeviceIdWebsocketOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostDevicesByDeviceIdWebsocketOutput = validatePostDevicesByDeviceIdWebsocketOutput;
/**
 * This function validates the inputs of a POST request on /devices/{device_id}/signaling
 */
function validatePostDevicesByDeviceIdSignalingInput(parameters, body) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validatePostDevicesByDeviceIdSignalingInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
        if (!(0, basicValidation_1.validatePeerconnectionUrl)(parameters["peerconnection_url"])) {
            validatePostDevicesByDeviceIdSignalingInput.errors = basicValidation_1.validatePeerconnectionUrl.errors;
            return false;
        }
    }
    if (!(0, basicValidation_1.validatePostDevicesByDeviceIdSignalingRequestBody)(body)) {
        validatePostDevicesByDeviceIdSignalingInput.errors = basicValidation_1.validatePostDevicesByDeviceIdSignalingRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePostDevicesByDeviceIdSignalingInput = validatePostDevicesByDeviceIdSignalingInput;
/**
 * This function validates the outputs to a POST request on /devices/{device_id}/signaling
 */
function validatePostDevicesByDeviceIdSignalingOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostDevicesByDeviceIdSignalingOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostDevicesByDeviceIdSignalingOutput = validatePostDevicesByDeviceIdSignalingOutput;
/**
 * This function validates the inputs of a GET request on /peerconnections
 */
function validateGetPeerconnectionsInput() {
    return true;
}
exports.validateGetPeerconnectionsInput = validateGetPeerconnectionsInput;
/**
 * This function validates the outputs to a GET request on /peerconnections
 */
function validateGetPeerconnectionsOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validateGetPeerconnectionsResponse200)(response.body)) {
            validateGetPeerconnectionsOutput.errors = basicValidation_1.validateGetPeerconnectionsResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetPeerconnectionsOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetPeerconnectionsOutput = validateGetPeerconnectionsOutput;
/**
 * This function validates the inputs of a POST request on /peerconnections
 */
function validatePostPeerconnectionsInput(parameters, body) {
    if (parameters) {
        if (parameters["closedUrl"] &&
            !(0, basicValidation_1.validateClosedUrl)(parameters["closedUrl"])) {
            validatePostPeerconnectionsInput.errors = basicValidation_1.validateClosedUrl.errors;
            return false;
        }
        if (parameters["statusChangedUrl"] &&
            !(0, basicValidation_1.validateStatusChangedUrl)(parameters["statusChangedUrl"])) {
            validatePostPeerconnectionsInput.errors = basicValidation_1.validateStatusChangedUrl.errors;
            return false;
        }
    }
    if (!(0, basicValidation_1.validatePostPeerconnectionsRequestBody)(body)) {
        validatePostPeerconnectionsInput.errors = basicValidation_1.validatePostPeerconnectionsRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePostPeerconnectionsInput = validatePostPeerconnectionsInput;
/**
 * This function validates the outputs to a POST request on /peerconnections
 */
function validatePostPeerconnectionsOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 201) {
        if (!(0, basicValidation_1.validatePostPeerconnectionsResponse201)(response.body)) {
            validatePostPeerconnectionsOutput.errors = basicValidation_1.validatePostPeerconnectionsResponse201.errors;
            return false;
        }
        return true;
    }
    if (response.status === 202) {
        if (!(0, basicValidation_1.validatePostPeerconnectionsResponse202)(response.body)) {
            validatePostPeerconnectionsOutput.errors = basicValidation_1.validatePostPeerconnectionsResponse202.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostPeerconnectionsOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostPeerconnectionsOutput = validatePostPeerconnectionsOutput;
/**
 * This function validates the inputs of a GET request on /peerconnections/{peerconnection_id}
 */
function validateGetPeerconnectionsByPeerconnectionIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validatePeerconnectionId)(parameters["peerconnection_id"])) {
            validateGetPeerconnectionsByPeerconnectionIdInput.errors =
                basicValidation_1.validatePeerconnectionId.errors;
            return false;
        }
    }
    return true;
}
exports.validateGetPeerconnectionsByPeerconnectionIdInput = validateGetPeerconnectionsByPeerconnectionIdInput;
/**
 * This function validates the outputs to a GET request on /peerconnections/{peerconnection_id}
 */
function validateGetPeerconnectionsByPeerconnectionIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validateGetPeerconnectionsByPeerconnectionIdResponse200)(response.body)) {
            validateGetPeerconnectionsByPeerconnectionIdOutput.errors =
                basicValidation_1.validateGetPeerconnectionsByPeerconnectionIdResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetPeerconnectionsByPeerconnectionIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetPeerconnectionsByPeerconnectionIdOutput = validateGetPeerconnectionsByPeerconnectionIdOutput;
/**
 * This function validates the inputs of a DELETE request on /peerconnections/{peerconnection_id}
 */
function validateDeletePeerconnectionsByPeerconnectionIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validatePeerconnectionId)(parameters["peerconnection_id"])) {
            validateDeletePeerconnectionsByPeerconnectionIdInput.errors = basicValidation_1.validatePeerconnectionId.errors;
            return false;
        }
    }
    return true;
}
exports.validateDeletePeerconnectionsByPeerconnectionIdInput = validateDeletePeerconnectionsByPeerconnectionIdInput;
/**
 * This function validates the outputs to a DELETE request on /peerconnections/{peerconnection_id}
 */
function validateDeletePeerconnectionsByPeerconnectionIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 204) {
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateDeletePeerconnectionsByPeerconnectionIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateDeletePeerconnectionsByPeerconnectionIdOutput = validateDeletePeerconnectionsByPeerconnectionIdOutput;
//# sourceMappingURL=requestValidation.js.map