"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const express_1 = __importDefault(require("express"));
const operations = __importStar(require("../operations"));
const types_1 = require("./types");
const requestValidation_1 = require("./requestValidation");
function routes(options = {
    security: {
        JWT: (_req, _scopes) => {
            throw new Error("JWT authentication not implemented");
        },
    },
}) {
    const router = express_1.default.Router();
    async function handleSecurityRequirement(request, securityRequirement) {
        let userData = {};
        for (const method in securityRequirement) {
            userData[method] = await options.security[method](request, securityRequirement[method]);
        }
        return userData;
    }
    router.get("/devices", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetDevicesInput)()) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetDevicesInput.errors, 400);
            }
            const result = await operations.getDevices(userData);
            if (!(0, requestValidation_1.validateGetDevicesOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetDevicesOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/devices", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            changedUrl: req.query["changedUrl"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostDevicesInput)(parameters, body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostDevicesInput.errors, 400);
            }
            const result = await operations.postDevices(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostDevicesOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostDevicesOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/devices/:device_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
            flat_group: req.query["flat_group"],
        };
        try {
            if (!(0, requestValidation_1.validateGetDevicesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetDevicesByDeviceIdInput.errors, 400);
            }
            const result = await operations.getDevicesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validateGetDevicesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetDevicesByDeviceIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch("/devices/:device_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:edit"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
            changedUrl: req.query["changedUrl"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchDevicesByDeviceIdInput)(parameters, body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePatchDevicesByDeviceIdInput.errors, 400);
            }
            const result = await operations.patchDevicesByDeviceId(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchDevicesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePatchDevicesByDeviceIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/devices/:device_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteDevicesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateDeleteDevicesByDeviceIdInput.errors, 400);
            }
            const result = await operations.deleteDevicesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteDevicesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateDeleteDevicesByDeviceIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/devices/:device_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
            changedUrl: req.query["changedUrl"],
        };
        try {
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostDevicesByDeviceIdInput.errors, 400);
            }
            const result = await operations.postDevicesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostDevicesByDeviceIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/devices/:device_id/availability", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:edit"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdAvailabilityInput)(parameters, body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostDevicesByDeviceIdAvailabilityInput.errors, 400);
            }
            const result = await operations.postDevicesByDeviceIdAvailability(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdAvailabilityOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostDevicesByDeviceIdAvailabilityOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/devices/:device_id/websocket", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:connect"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
        };
        try {
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdWebsocketInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostDevicesByDeviceIdWebsocketInput.errors, 400);
            }
            const result = await operations.postDevicesByDeviceIdWebsocket(parameters, userData);
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdWebsocketOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostDevicesByDeviceIdWebsocketOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/devices/:device_id/signaling", async (req, res, next) => {
        const security = [
            {
                JWT: ["device", "device:signal"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
            peerconnection_url: req.query["peerconnection_url"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdSignalingInput)(parameters, body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostDevicesByDeviceIdSignalingInput.errors, 400);
            }
            const result = await operations.postDevicesByDeviceIdSignaling(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostDevicesByDeviceIdSignalingOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostDevicesByDeviceIdSignalingOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/peerconnections", async (req, res, next) => {
        const security = [
            {
                JWT: ["peerconnection", "peerconnection:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetPeerconnectionsInput)()) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetPeerconnectionsInput.errors, 400);
            }
            const result = await operations.getPeerconnections(userData);
            if (!(0, requestValidation_1.validateGetPeerconnectionsOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetPeerconnectionsOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/peerconnections", async (req, res, next) => {
        const security = [
            {
                JWT: ["peerconnection", "peerconnection:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            closedUrl: req.query["closedUrl"],
            statusChangedUrl: req.query["statusChangedUrl"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostPeerconnectionsInput)(parameters, body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostPeerconnectionsInput.errors, 400);
            }
            const result = await operations.postPeerconnections(parameters, body, userData);
            if (!(0, requestValidation_1.validatePostPeerconnectionsOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostPeerconnectionsOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/peerconnections/:peerconnection_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["peerconnection", "peerconnection:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            peerconnection_id: req.params["peerconnection_id"],
        };
        try {
            if (!(0, requestValidation_1.validateGetPeerconnectionsByPeerconnectionIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetPeerconnectionsByPeerconnectionIdInput.errors, 400);
            }
            const result = await operations.getPeerconnectionsByPeerconnectionId(parameters, userData);
            if (!(0, requestValidation_1.validateGetPeerconnectionsByPeerconnectionIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetPeerconnectionsByPeerconnectionIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/peerconnections/:peerconnection_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["peerconnection", "peerconnection:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            peerconnection_id: req.params["peerconnection_id"],
        };
        try {
            if (!(0, requestValidation_1.validateDeletePeerconnectionsByPeerconnectionIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateDeletePeerconnectionsByPeerconnectionIdInput.errors, 400);
            }
            const result = await operations.deletePeerconnectionsByPeerconnectionId(parameters, userData);
            if (!(0, requestValidation_1.validateDeletePeerconnectionsByPeerconnectionIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateDeletePeerconnectionsByPeerconnectionIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
exports.default = routes;
//# sourceMappingURL=routes.js.map