"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServiceModel = exports.ServiceConfigModel = exports.PeerconnectionModel = exports.TimeSlotModel = exports.AvailabilityRuleModel = exports.DeviceReferenceModel = exports.InstantiableBrowserDeviceModel = exports.InstantiableCloudDeviceModel = exports.DeviceGroupModel = exports.ConcreteDeviceModel = exports.InstantiableDeviceOverviewModel = exports.DeviceOverviewModel = exports.isInstantiableDeviceModel = exports.isInstantiableBrowserDeviceModel = exports.isInstantiableCloudDeviceModel = exports.isDeviceGroupModel = exports.isConcreteDeviceModel = void 0;
const typeorm_1 = require("typeorm");
function isConcreteDeviceModel(device) {
    return device.type === 'device';
}
exports.isConcreteDeviceModel = isConcreteDeviceModel;
function isDeviceGroupModel(device) {
    return device.type === 'group';
}
exports.isDeviceGroupModel = isDeviceGroupModel;
function isInstantiableCloudDeviceModel(device) {
    return device.type === 'cloud instantiable';
}
exports.isInstantiableCloudDeviceModel = isInstantiableCloudDeviceModel;
function isInstantiableBrowserDeviceModel(device) {
    return device.type === 'edge instantiable';
}
exports.isInstantiableBrowserDeviceModel = isInstantiableBrowserDeviceModel;
function isInstantiableDeviceModel(device) {
    return (isInstantiableBrowserDeviceModel(device) || isInstantiableCloudDeviceModel(device));
}
exports.isInstantiableDeviceModel = isInstantiableDeviceModel;
let DeviceOverviewModel = class DeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "description", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceOverviewModel.prototype, "owner", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], DeviceOverviewModel.prototype, "deletedAt", void 0);
DeviceOverviewModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Device' }),
    (0, typeorm_1.TableInheritance)({
        column: {
            type: 'varchar',
            name: 'type',
            enum: ['device', 'group', 'cloud instantiable', 'edge instantiable'],
        },
    })
], DeviceOverviewModel);
exports.DeviceOverviewModel = DeviceOverviewModel;
let InstantiableDeviceOverviewModel = class InstantiableDeviceOverviewModel extends DeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.OneToMany)(() => ConcreteDeviceModel, (concreteDevice) => concreteDevice.instanceOf, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], InstantiableDeviceOverviewModel.prototype, "instances", void 0);
InstantiableDeviceOverviewModel = __decorate([
    (0, typeorm_1.ChildEntity)()
], InstantiableDeviceOverviewModel);
exports.InstantiableDeviceOverviewModel = InstantiableDeviceOverviewModel;
let ConcreteDeviceModel = class ConcreteDeviceModel extends DeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ConcreteDeviceModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Boolean)
], ConcreteDeviceModel.prototype, "connected", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => TimeSlotModel, (timeslot) => timeslot.device, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ConcreteDeviceModel.prototype, "announcedAvailability", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => AvailabilityRuleModel, (timeslot) => timeslot.device, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ConcreteDeviceModel.prototype, "availabilityRules", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ConcreteDeviceModel.prototype, "experiment", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ConcreteDeviceModel.prototype, "token", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => ServiceModel, (serviceDescription) => serviceDescription.device, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ConcreteDeviceModel.prototype, "services", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => InstantiableDeviceOverviewModel, (instantiableDevice) => instantiableDevice.instances),
    __metadata("design:type", InstantiableDeviceOverviewModel)
], ConcreteDeviceModel.prototype, "instanceOf", void 0);
ConcreteDeviceModel = __decorate([
    (0, typeorm_1.ChildEntity)('device')
], ConcreteDeviceModel);
exports.ConcreteDeviceModel = ConcreteDeviceModel;
let DeviceGroupModel = class DeviceGroupModel extends DeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceGroupModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => DeviceReferenceModel, (deviceReference) => deviceReference.group, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], DeviceGroupModel.prototype, "devices", void 0);
DeviceGroupModel = __decorate([
    (0, typeorm_1.ChildEntity)('group')
], DeviceGroupModel);
exports.DeviceGroupModel = DeviceGroupModel;
let InstantiableCloudDeviceModel = class InstantiableCloudDeviceModel extends InstantiableDeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], InstantiableCloudDeviceModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], InstantiableCloudDeviceModel.prototype, "instantiateUrl", void 0);
InstantiableCloudDeviceModel = __decorate([
    (0, typeorm_1.ChildEntity)('cloud instantiable')
], InstantiableCloudDeviceModel);
exports.InstantiableCloudDeviceModel = InstantiableCloudDeviceModel;
let InstantiableBrowserDeviceModel = class InstantiableBrowserDeviceModel extends InstantiableDeviceOverviewModel {
};
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], InstantiableBrowserDeviceModel.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], InstantiableBrowserDeviceModel.prototype, "codeUrl", void 0);
InstantiableBrowserDeviceModel = __decorate([
    (0, typeorm_1.ChildEntity)('edge instantiable')
], InstantiableBrowserDeviceModel);
exports.InstantiableBrowserDeviceModel = InstantiableBrowserDeviceModel;
let DeviceReferenceModel = class DeviceReferenceModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], DeviceReferenceModel.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceReferenceModel.prototype, "url", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => ServiceConfigModel, (serviceConfig) => serviceConfig.device, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], DeviceReferenceModel.prototype, "config", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => DeviceGroupModel, (deviceGroup) => deviceGroup.devices),
    __metadata("design:type", DeviceGroupModel)
], DeviceReferenceModel.prototype, "group", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], DeviceReferenceModel.prototype, "deletedAt", void 0);
DeviceReferenceModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'DeviceReference' })
], DeviceReferenceModel);
exports.DeviceReferenceModel = DeviceReferenceModel;
let AvailabilityRuleModel = class AvailabilityRuleModel {
    nullToUndefined() {
        if (this.available == null)
            this.available = undefined;
        if (this.start == null)
            this.start = undefined;
        if (this.end == null)
            this.end = undefined;
        if (this.frequency == null)
            this.frequency = undefined;
        if (this.until == null)
            this.until = undefined;
        if (this.count == null)
            this.count = undefined;
    }
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], AvailabilityRuleModel.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Boolean)
], AvailabilityRuleModel.prototype, "available", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], AvailabilityRuleModel.prototype, "start", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], AvailabilityRuleModel.prototype, "end", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], AvailabilityRuleModel.prototype, "frequency", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], AvailabilityRuleModel.prototype, "until", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", Number)
], AvailabilityRuleModel.prototype, "count", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ConcreteDeviceModel, (device) => device.availabilityRules),
    __metadata("design:type", ConcreteDeviceModel)
], AvailabilityRuleModel.prototype, "device", void 0);
__decorate([
    (0, typeorm_1.AfterLoad)(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], AvailabilityRuleModel.prototype, "nullToUndefined", null);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], AvailabilityRuleModel.prototype, "deletedAt", void 0);
AvailabilityRuleModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'AvailabilityRule' })
], AvailabilityRuleModel);
exports.AvailabilityRuleModel = AvailabilityRuleModel;
let TimeSlotModel = class TimeSlotModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], TimeSlotModel.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], TimeSlotModel.prototype, "start", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", Number)
], TimeSlotModel.prototype, "end", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ConcreteDeviceModel, (device) => device.announcedAvailability),
    __metadata("design:type", ConcreteDeviceModel)
], TimeSlotModel.prototype, "device", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], TimeSlotModel.prototype, "deletedAt", void 0);
TimeSlotModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'TimeSlot' })
], TimeSlotModel);
exports.TimeSlotModel = TimeSlotModel;
let PeerconnectionModel = class PeerconnectionModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], PeerconnectionModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], PeerconnectionModel.prototype, "status", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => DeviceReferenceModel, { onDelete: 'CASCADE', cascade: true }),
    (0, typeorm_1.JoinColumn)(),
    __metadata("design:type", DeviceReferenceModel)
], PeerconnectionModel.prototype, "deviceA", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => DeviceReferenceModel, { onDelete: 'CASCADE', cascade: true }),
    (0, typeorm_1.JoinColumn)(),
    __metadata("design:type", DeviceReferenceModel)
], PeerconnectionModel.prototype, "deviceB", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], PeerconnectionModel.prototype, "deletedAt", void 0);
PeerconnectionModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Peerconnection' })
], PeerconnectionModel);
exports.PeerconnectionModel = PeerconnectionModel;
let ServiceConfigModel = class ServiceConfigModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], ServiceConfigModel.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ServiceConfigModel.prototype, "serviceType", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ServiceConfigModel.prototype, "serviceId", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ServiceConfigModel.prototype, "remoteServiceId", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ServiceConfigModel.prototype, "config", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => DeviceReferenceModel, (deviceReference) => deviceReference.config),
    __metadata("design:type", DeviceReferenceModel)
], ServiceConfigModel.prototype, "device", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], ServiceConfigModel.prototype, "deletedAt", void 0);
ServiceConfigModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'ServiceConfig' })
], ServiceConfigModel);
exports.ServiceConfigModel = ServiceConfigModel;
let ServiceModel = class ServiceModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    __metadata("design:type", Number)
], ServiceModel.prototype, "id", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ServiceModel.prototype, "description", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ConcreteDeviceModel, (concreteDevice) => concreteDevice.services),
    __metadata("design:type", ConcreteDeviceModel)
], ServiceModel.prototype, "device", void 0);
ServiceModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'ServiceDescription' })
], ServiceModel);
exports.ServiceModel = ServiceModel;
//# sourceMappingURL=model.js.map